(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["artMonitor"] = factory();
	else
		root["artMonitor"] = factory();
})(self, () => {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ([
/* 0 */
/***/ ((module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _src_performance_index_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1);
/* module decorator */ module = __webpack_require__.hmd(module);
// import * as monitor from 'art-monitor'
// console.log(monitor.monitor)

// monitor.monitor()



const monitor = {
  init() {
    console.log("Monitoring init...");
    // WebVitals
    console.log("WebVitals", new _src_performance_index_js__WEBPACK_IMPORTED_MODULE_0__.WebVitals());
  },
};

// 根据你的库目标，选择合适的导出方式
if (typeof window !== "undefined" && typeof window.artmonitor === "undefined") {
  window.artmonitor = monitor;
} else if (
   true &&
  typeof module.exports === "object"
) {
  module.exports = monitor;
}

// export default monitor

// monitor.init()

// export function monitor() {
//     console.log('Monitoring data...');
// }


/***/ }),
/* 1 */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   WebVitals: () => (/* binding */ WebVitals),
/* harmony export */   afterLoad: () => (/* binding */ afterLoad)
/* harmony export */ });
/* harmony import */ var _store_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/* harmony import */ var _utils_index_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(3);



// function observe(type, handler) {
//   new PerformanceObserver((entryList) => {
//     const entries = entryList.getEntries();
//     const entry = entries[entries.length - 1];
//     console.log(`${type}`, entry);
//     handler(entry);
//   }).observe({ type: type, buffered: true });
// }

class WebVitals {
  
  // 本地暂存的数据map结构
  metrics = _store_js__WEBPACK_IMPORTED_MODULE_0__["default"];

  constructor () {
    this.initLCP();
    this.initCLS();
    this.initResourceFlow();
    afterLoad(()=>{
      this.initNavigationTiming();
      this.initFP();
      this.initFCP();
      this.initFID();
      this.perfSendHandler();
    })
  };

  // 性能上报的策略
  perfSendHandler(){};

  // 初始化 FP 的获取以及返回
  initFP(){
    const getFP = () => {
      const [entry] = performance.getEntriesByName("first-paint");
      return entry;
    };
    const entry = getFP();
    const metrics = {
      startTime: entry?.startTime.toFixed(2),
      entry,
    };
    this.metrics.set(_store_js__WEBPACK_IMPORTED_MODULE_0__.metricsName.FP, metrics);
  };

  // 初始化 FCP 的获取以及返回
  initFCP(){
    const getFCP = () => {
      const [entry] = performance.getEntriesByName("first-contentful-paint");
      return entry;
    };
    const entry = getFCP();
    const metrics = {
      startTime: entry?.startTime.toFixed(2),
      entry,
    };
    this.metrics.set(_store_js__WEBPACK_IMPORTED_MODULE_0__.metricsName.FCP, metrics);
  };

  // 初始化 LCP 的获取以及返回
  initLCP(){
    const getLCP = (entryHandler) => {
      return (0,_utils_index_js__WEBPACK_IMPORTED_MODULE_1__.observe)("largest-contentful-paint", entryHandler);
    };
    const entryHandler = (entry) => {
      const metrics = {
        startTime: entry?.startTime.toFixed(2),
        entry,
      };
      this.metrics.set(_store_js__WEBPACK_IMPORTED_MODULE_0__.metricsName.LCP, metrics);
    };
    getLCP(entryHandler);
  };

  // 初始化 FID 的获取 及返回
  initFID(){
    const getFID = (entryHandler) => {
      return (0,_utils_index_js__WEBPACK_IMPORTED_MODULE_1__.observe)("first-input", entryHandler);
    };
    const entryHandler = (entry) => {
      const metrics = {
        delay: entry.processingStart - entry.startTime,
        entry,
      };
      this.metrics.set(_store_js__WEBPACK_IMPORTED_MODULE_0__.metricsName.FID, metrics);
    };
    getFID(entryHandler);
  };

  // 初始化 CLS 的获取以及返回
  initCLS(){
    const getCLS = (entryHandler) => {
      return (0,_utils_index_js__WEBPACK_IMPORTED_MODULE_1__.observe)("layout-shift", entryHandler);
    };

    let clsValue = 0;
    let clsEntries = [];

    let sessionValue = 0;
    let sessionEntries = [];

    const entryHandler = (entry) => {
      if (!entry.hadRecentInput) {
        const firstSessionEntry = sessionEntries[0];
        const lastSessionEntry = sessionEntries[sessionEntries.length - 1];

        // 如果条目与上一条目的相隔时间小于 1 秒且
        // 与会话中第一个条目的相隔时间小于 5 秒，那么将条目
        // 包含在当前会话中。否则，开始一个新会话。
        if (
          sessionValue &&
          entry.startTime - lastSessionEntry.startTime < 1000 &&
          entry.startTime - firstSessionEntry.startTime < 5000
        ) {
          sessionValue += entry.value;
          sessionEntries.push(entry);
        } else {
          sessionValue = entry.value;
          sessionEntries = [entry];
        }

        // 如果当前会话值大于当前 CLS 值，
        // 那么更新 CLS 及其相关条目。
        if (sessionValue > clsValue) {
          clsValue = sessionValue;
          clsEntries = sessionEntries;

          // 记录 CLS 到 Map 里
          const metrics = {
            entry,
            clsValue,
            clsEntries,
          };
          this.metrics.set(_store_js__WEBPACK_IMPORTED_MODULE_0__.metricsName.CLS, metrics);
        }
      }
    };
    getCLS(entryHandler);
  };

  // 初始化 NT 的获取以及返回
  initNavigationTiming(){
    const getNavigationTiming = () => {
      const resolveNavigationTiming = (entry) => {
        const {
          domainLookupStart,
          domainLookupEnd,
          connectStart,
          connectEnd,
          secureConnectionStart,
          requestStart,
          responseStart,
          responseEnd,
          domInteractive,
          domContentLoadedEventEnd,
          loadEventStart,
          fetchStart,
        } = entry;

        return {
          // 关键时间点
          FP: responseEnd - fetchStart,
          TTI: domInteractive - fetchStart,
          DomReady: domContentLoadedEventEnd - fetchStart,
          Load: loadEventStart - fetchStart,
          FirstByte: responseStart - domainLookupStart,
          // 关键时间段
          DNS: domainLookupEnd - domainLookupStart,
          TCP: connectEnd - connectStart,
          SSL: secureConnectionStart ? connectEnd - secureConnectionStart : 0,
          TTFB: responseStart - requestStart,
          Trans: responseEnd - responseStart,
          DomParse: domInteractive - responseEnd,
          Res: loadEventStart - domContentLoadedEventEnd,
        };
      };

      const navigation =
        // W3C Level2  PerformanceNavigationTiming
        // 使用了High-Resolution Time，时间精度可以达毫秒的小数点好几位。
        performance.getEntriesByType("navigation").length > 0
          ? performance.getEntriesByType("navigation")[0]
          : performance.timing; // W3C Level1  (目前兼容性高，仍然可使用，未来可能被废弃)。
      return resolveNavigationTiming(navigation);
    };

    const navigationTiming = getNavigationTiming();
    const metrics = navigationTiming;
    this.metrics.set(_store_js__WEBPACK_IMPORTED_MODULE_0__.metricsName.NT, metrics);
  };

  // 初始化 RF 的获取以及返回
  initResourceFlow() {
    const getRF = (callback) => {
      const resource = performance.getEntriesByType("resource");
      let cacheQuantity = 0;
      const formatResourceArray = resource.map((item) => {
        if (item.duration == 0 && item.transferSize !== 0) cacheQuantity++;
        const data = {
          ...item,
          name: item.name, //资源地址
          startTime: item.startTime, //开始时间
          responseEnd: item.responseEnd, //结束时间
          time: item.duration, //消耗时间
          initiatorType: item.initiatorType, //资源类型
          transferSize: item.transferSize, //传输大小
          //请求响应耗时 ttfb = item.responseStart - item.startTime
          //内容下载耗时 tran = item.responseEnd - item.responseStart
          //但是受到跨域资源影响。除非资源设置允许获取timing
        };
        callback(data)
        return data
      });
      console.log("缓存命中率", (cacheQuantity / resource.length).toFixed(2));
    };

    const getResourceFlow = (resourceFlow) => {

      const entryHandler = (entry) => {
        const {
          name,
          transferSize,
          initiatorType,
          startTime,
          responseEnd,
          domainLookupEnd,
          domainLookupStart,
          connectStart,
          connectEnd,
          secureConnectionStart,
          responseStart,
          requestStart,
        } = entry;
        resourceFlow.push({
          // name 资源地址
          name,
          // transferSize 传输大小
          transferSize,
          // initiatorType 资源类型
          initiatorType,
          // startTime 开始时间
          startTime,
          // responseEnd 结束时间
          responseEnd,
          // 贴近 Chrome 的近似分析方案，受到跨域资源影响
          dnsLookup: domainLookupEnd - domainLookupStart,
          initialConnect: connectEnd - connectStart,
          ssl: connectEnd - secureConnectionStart,
          request: responseStart - requestStart,
          ttfb: responseStart - requestStart,
          contentDownload: responseStart - requestStart,
        });
      };

      return getRF(entryHandler);
    };

    const resourceFlow = [];
    const resObserve = getResourceFlow(resourceFlow);

    const stopListening = () => {
      if (resObserve) {
        resObserve.disconnect();
      }
      const metrics = resourceFlow;
      this.metrics.set(_store_js__WEBPACK_IMPORTED_MODULE_0__.metricsName.RF, metrics);
    };
    // 当页面 pageshow 触发时，中止
    window.addEventListener("pageshow", stopListening, {
      once: true,
      capture: true,
    });
  }
}


const afterLoad = (callback) => {
  if (document.readyState === "complete") {
    setTimeout(callback);
  } else {
    window.addEventListener("pageshow", callback, {
      once: true,
      capture: true,
    });
  }
};


/***/ }),
/* 2 */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__),
/* harmony export */   metricsName: () => (/* binding */ metricsName)
/* harmony export */ });
const metricsName = {
  FP: "first-paint",
  FCP: "first-contentful-paint",
  LCP: "largest-contentful-paint",
  FID: "first-input-delay",
  CLS: "cumulative-layout-shift",
  NT: "navigation-timing",
  RF: "resource-flow",
};

const metricsStore = {
  state: new Map(),
  
  set(key, value) {
    this.state.set(key, value);
  },

  add(key, value) {
    const keyValue = this.state.get(key);
    this.state.set(key, keyValue ? keyValue.concat([value]) : [value]);
  },

  get(key) {
    return this.state.get(key);
  },

  has(key) {
    return this.state.has(key);
  },

  clear() {
    this.state.clear();
  },

  getValues() {
    // Map 转为 对象 返回
    return Object.fromEntries(this.state);
  }

};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (metricsStore);


/***/ }),
/* 3 */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   observe: () => (/* binding */ observe)
/* harmony export */ });
function observe(type, handler) {
  new PerformanceObserver((entryList) => {
    const entries = entryList.getEntries();
    const entry = entries[entries.length - 1];
    console.log(`${type}`, entry);
    handler(entry);
  }).observe({ type: type, buffered: true });
}

// export const observe = (type, callback) => {
//   // 类型合规，就返回 observe
//   if (PerformanceObserver.supportedEntryTypes?.includes(type)) {
//     const ob: PerformanceObserver = new PerformanceObserver((l) => l.getEntries().map(callback));

//     ob.observe({ type, buffered: true });
//     return ob;
//   }
//   return undefined;
// };

/***/ })
/******/ 	]);
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			id: moduleId,
/******/ 			loaded: false,
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/harmony module decorator */
/******/ 	(() => {
/******/ 		__webpack_require__.hmd = (module) => {
/******/ 			module = Object.create(module);
/******/ 			if (!module.children) module.children = [];
/******/ 			Object.defineProperty(module, 'exports', {
/******/ 				enumerable: true,
/******/ 				set: () => {
/******/ 					throw new Error('ES Modules may not assign module.exports or exports.*, Use ESM export syntax, instead: ' + module.id);
/******/ 				}
/******/ 			});
/******/ 			return module;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __webpack_require__(0);
/******/ 	__webpack_exports__ = __webpack_exports__["default"];
/******/ 	
/******/ 	return __webpack_exports__;
/******/ })()
;
});